'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Deferred = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var RawDeferred = function (_PureComponent) {
    _inherits(RawDeferred, _PureComponent);

    function RawDeferred() {
        _classCallCheck(this, RawDeferred);

        var _this = _possibleConstructorReturn(this, (RawDeferred.__proto__ || Object.getPrototypeOf(RawDeferred)).apply(this, arguments));

        _this.state = {
            isResolved: false
        };
        return _this;
    }

    _createClass(RawDeferred, [{
        key: 'componentWillMount',
        value: function componentWillMount() {
            this.delay();
        }
    }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
            clearTimeout(this.timeout);
        }
    }, {
        key: 'componentWillUpdate',
        value: function componentWillUpdate() {
            console.log('update');
            clearTimeout(this.timeout);
            this.delay();
        }
    }, {
        key: 'render',
        value: function render() {
            var isResolved = this.state.isResolved;
            var _props = this.props,
                render = _props.render,
                children = _props.children;

            return isResolved ? render() : children || null; //weird React typings...
        }
    }, {
        key: 'delay',
        value: function delay() {
            var _this2 = this;

            this.timeout = window.setTimeout(function () {
                _this2.setState({
                    isResolved: true
                });
            }, this.props.delay);
        }
    }]);

    return RawDeferred;
}(_react.PureComponent);

RawDeferred.defaultProps = {
    delay: 0
};
var Deferred = exports.Deferred = RawDeferred;